package net.minecraft.world.level.levelgen.placement;

import net.minecraft.world.level.levelgen.feature.configurations.DecoratorConfiguration;
import net.minecraft.world.level.levelgen.Heightmap;
import java.util.stream.IntStream;
import java.util.stream.Stream;
import net.minecraft.core.BlockPos;
import java.util.Random;
import net.minecraft.world.level.chunk.ChunkGenerator;
import net.minecraft.world.level.LevelAccessor;
import com.mojang.serialization.Codec;

public class CountChanceHeightmapDecorator extends FeatureDecorator<FrequencyChanceDecoratorConfiguration> {
    public CountChanceHeightmapDecorator(final Codec<FrequencyChanceDecoratorConfiguration> codec) {
        super(codec);
    }
    
    @Override
    public Stream<BlockPos> getPositions(final LevelAccessor bqc, final ChunkGenerator cha, final Random random, final FrequencyChanceDecoratorConfiguration cse, final BlockPos fu) {
        final int integer5;
        final int integer6;
        final int integer7;
        return IntStream.range(0, cse.count).filter(integer -> random.nextFloat() < cse.chance).<BlockPos>mapToObj(integer -> {
            integer5 = random.nextInt(16) + fu.getX();
            integer6 = random.nextInt(16) + fu.getZ();
            integer7 = bqc.getHeight(Heightmap.Types.MOTION_BLOCKING, integer5, integer6);
            return new BlockPos(integer5, integer7, integer6);
        });
    }
}
